; [url=http://www.masm32.com/board/index.php?topic=1589.msg12747#msg12747]original source[/url] (stillslow.zip)
.nolist
include \masm32\include\masm32rt.inc

.686
; .k3d
.xmm
include \masm32\macros\timers.asm

Main		proto
SzCpy10	proto :DWORD,:DWORD
MbCopy	proto :DWORD,:DWORD
szCopyMMX	proto :DWORD,:DWORD
SzCpy11	proto :DWORD,:DWORD
szCopyMMX1	proto :DWORD,:DWORD
szCopyXMM	proto :DWORD,:DWORD

testmode=0

testjj MACRO arg1, arg2
  invoke memfill, offset arg1, sizeof arg1, 0
  if testmode eq 1
  	print chr$(13, 10, "Testing Mark's code:")
	invoke szCopyMMX1, offset arg2, offset arg1
  elseif testmode eq 2
  	print chr$(13, 10, "Testing Lingo's code, SzCpy11:")
	invoke SzCpy11, offset arg1, offset arg2
  else
  	print chr$(13, 10, "Testing JJ's code:")
	invoke szCopyMMX, offset arg2, offset arg1
  endif
  print chr$(13,10, "Source=")
  print offset arg2
  print chr$(13,10, "  Dest=")
  print offset arg1
ENDM

.data
CanSSE2		dd -1
c15	db "B23456789012345", 0
c16	db "C234567890123456", 0
c17	db "D2345678901234567", 0

d15	db 15 dup ("b"), "x"
d16	db 16 dup ("c"), "x"
d17	db 17 dup ("d"), "x"

align 16

spoil1	db 1, 2, 3		; badly aligned source - REMOVE TO SEE A CRASH (Ctrl C terminates)

String1	DB  "Sample String 01234 56789 ABCD", 13, 10, " AaBbCcDdEeFfGgHhIiJjKkLlMMNnOoP"
	DB "pQqRrSsTtUuVvWwXxYyZz Now I Know My ABC's, Won't You Come Play",13, 10
	DB  "Sample String 01234 56789 ABCDEF AaBbCcDdEeFfGgHhIiJjKkLlMMNnOoP",\
	"pQqRrSsTtUuVvWwXxYyZz Now I Know My ABC's, Won't You Come Play",13, 10
	DB  "Sample String 01234 56789 ABCDEF AaBbCcDdEeFfGgHhIiJjKkLlMMNnOoP",\
	"pQqRrSsTtUuVvWwXxYyZz Now I Know My ABC's, Won't You Come Play",13, 10
	DB  "Sample String 01234 56789 ABCDEF AaBbCcDdEeFfGgHhIiJjKkLlMMNnOoP",\
	"pQqRrSsTtUuVvWwXxYyZz Now I Know My ABC's, Won't You Come Play", 13, 10
	DB 0

	db "RUBBISH for testing the boundaries", 13, 10, 0
align 16

spoil2	db 1, 2, 3, 4, 5		; badly aligned destination (removing does NOT cause a crash)

String2     DB  16*32 dup(0)
                db 0, "rubbish for testing the boundaries", 13, 10, 10
                db 100 dup(0)	; see what happens if you comment this line

LOOP_COUNT  EQU 1000000        ; 1M iterations per timing result
SleepTime = 50

SzSzCpy10	DB  "SzCpy10        - > Lingo ->        MMX: ",0
sszCopyMMX	DB  "szCopyMMX   -> Mark Larson   ->    MMX: ",0
SzSzCpy11	DB   "SzCpy11  -- > Lingo ->  MMX   ->  Fast: ",0
sszCopyMMX1	DB  "szCopyMMX1-> Mark Larson -> MMX-> Fast: ",0

.code

Start:
	if 0
	testmode=0
	testjj d15, c15	; test the 16-bytes boundary
	testjj d16, c16
	testjj d17, c17
	print chr$(13,10)
	testmode=1
	testjj d15, c15	; test the 16-bytes boundary
	testjj d16, c16
	testjj d17, c17
	print chr$(13,10)
	testmode=2
	testjj d15, c15	; test the 16-bytes boundary
	testjj d16, c16
	testjj d17, c17
	endif
    	; int 3

  Invoke Main
  Invoke ExitProcess,0

Main Proc
    print chr$(13, 10, 10, " Timing routines by MichaelW from MASM32 forums, http://www.masmforum.com/",13,10)
    ; mov   eax, input(" Please terminate any high-priority tasks and press ENTER to begin.")

	print chr$(13,10,13,10," 512-byte string copy timing results:",13,10,13,10)
	print " len of source string = "
	print str$(len(offset String1)), 13, 10
	print " alignment: offset src="
	print str$(offset String1)
	print ", dest="
	print str$(offset String2), 13, 10
    	print " len of szCopyXMM: "
    	mov eax, offset jj1
    	sub eax, szCopyXMM
    	print str$(eax), 13, 10, 10
    top = 0		; change order
    seeresult = 0
   
    if seeresult eq 2	; test slows down enormously if you activate this
	invoke szCopyXMM, addr String2, addr String1
	; invoke MbCopy, addr String2, addr String1	; test if it works properly
	print chr$(13, 10, "Destination: ", 13, 10)
	print offset String2
    endif
  

; ---------- Lingo 1-------------------------------------  
    if top eq 1
    print addr SzSzCpy10
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke SzCpy10, addr String2, addr String1
    counter_end
    print str$(eax)
    print chr$(" clocks",13,10)
    if seeresult eq 1
	print chr$(13, 10, "Result= ", 9)
	print offset String2
    endif
    invoke Sleep, SleepTime
    endif
; -----------------------------------------------  
    if 1  ; top eq 1
    print chr$("szCopyXMM -> jj   -> ", 9, 9,"   xmm: ")
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke szCopyXMM, addr String2, addr String1
    counter_end
    print str$(eax)
    print chr$(" clocks",13,10)
    if seeresult eq 1
	print chr$(13, 10, "Result= ", 9)
	print offset String2
    endif
    invoke Sleep, SleepTime
    endif
; -----------------------------------------------  
    if top eq 1
    print chr$("MbCopy     -> jj   -> ", 9, 9,"   xmm: ")
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke MbCopy, addr String2, addr String1
    counter_end
    print str$(eax)
    print chr$(" clocks",13,10)
    if seeresult eq 1
	print chr$(13, 10, "Result= ", 9)
	print offset String2
    endif
    invoke Sleep, SleepTime
    endif
; -----------------------------------------------  
    print addr sszCopyMMX
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke szCopyMMX , addr String1, addr String2
    counter_end
    print str$(eax)
    print chr$(" clocks",13,10)
    if seeresult eq 1
	print chr$(13, 10, "Result= ", 9)
	print offset String2
    endif
    invoke Sleep, SleepTime
; -----------------------------------------------   
    print addr SzSzCpy11
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke SzCpy11, addr String1, addr String2
    counter_end
    print str$(eax)
    print chr$(" clocks",13,10)
    if seeresult eq 1
	print chr$(13, 10, "Result= ", 9)
	print offset String2
    endif
    invoke Sleep, SleepTime
; -----------------------------------------------  
    print addr sszCopyMMX1
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke szCopyMMX1 , addr String1, addr String2
    counter_end
    print str$(eax)
    print chr$(" clocks",13,10)
    if seeresult eq 1
	print chr$(13, 10, "Result= ", 9)
	print offset String2
    endif
    invoke Sleep, SleepTime
; -----------------------------------------------   
    print chr$(9,9,9,9,"szCopy", 9)
    counter_begin LOOP_COUNT/10, HIGH_PRIORITY_CLASS
;    call LoadFPU
;    int 3
    invoke szCopy, addr String1, addr String2
    counter_end
    print str$(eax)
    print chr$(" clocks",13,10)
    if seeresult eq 1
	print chr$(13, 10, "Result= ", 9)
	print offset String2
    endif
    invoke Sleep, SleepTime
; -----------------------------------------------   
    print chr$(9,9,9,9,"lstrcpy", 9)
    counter_begin LOOP_COUNT/10, HIGH_PRIORITY_CLASS
    invoke lstrcpy, addr String1, addr String2
    counter_end
    print str$(eax)
    print chr$(" clocks",13,10)
    if seeresult eq 1
	print chr$(13, 10, "Result= ", 9)
	print offset String2
    endif
    invoke Sleep, SleepTime
; -----------------------------------------------   

; ---------- Lingo 1-------------------------------------  
    if top eq 0
    print addr SzSzCpy10
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke SzCpy10, addr String2, addr String1
    counter_end
    print str$(eax)
    print chr$(" clocks",13,10)
    invoke Sleep, SleepTime
    endif
; -----------------------------------------------  
    if top eq 0
    print chr$("MbCopy     -> jj   -> ", 9, 9,"   xmm: ")
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke MbCopy, addr String2, addr String1
    counter_end
    print str$(eax)
    print chr$(" clocks",13,10)
    if seeresult eq 1
	print chr$(13, 10, "Result= ", 9)
	print offset String2
    endif
    invoke Sleep, SleepTime
    endif

    ; mov   eax, input(13,10," Press ENTER to exit...")
    ret
Main EndP



OPTION PROLOGUE:NONE   ; It  is SzCpy10  MMX by Lingo
OPTION EPILOGUE:NONE
comment * MMX by Lingo*
align 16
@@:
	movq		MM1,	[ecx+eax]
    movq		[edx+eax-8], MM0
@@2:
    movq		MM0,	[ecx+eax]					
	pcmpeqb	MM1,	MM7
	packsswb	MM1,	MM1
	movd		ebx,		MM1
	test			bl,		bl
	lea			eax,		[eax+8]
	je				@B
@@:									
	movzx	    ebx, byte ptr [ecx+eax-8]		
	add			eax, 1
	test			bl, bl
	mov			[edx+eax-9], bl
	jnz			@B
	mov			ebx, [esp+2*4]						
	ret			2*4
align 16
SzCpy10   proc    SzDest:DWORD, SzSource:DWORD
				mov		ecx, [esp+2*4]		; ecx = source
				xor		eax, eax
				mov		edx, [esp+1*4]		;  edx= destination
 				pxor		MM7,MM7
				movq	MM1, [ecx]
				mov		[esp+2*4], ebx		;  save ebx register
				je			@@2
 SzCpy10 endp


OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
align 16
MbCopy proc SzDest:DWORD, SzSource:DWORD
 ; ------- credits to [url=http://www.masm32.com/board/index.php?topic=1589.msg12747#msg12747]Lingo[/url] --------
	mov ecx, [esp+2*4]		; ecx = source
	xor eax, eax
	mov edx, [esp+1*4]		; edx= destination
	pxor xmm7,xmm7
	movq xmm1, qword ptr [ecx]
	; mov [esp+2*4], ebx		; save ebx register: not faster
	push ebx
 je @@2a

; align 16 makes it lose 10 cycles
@@:
	movq xmm1, qword ptr [ecx+eax]
	movq qword ptr [edx+eax-8], xmm0
@@2a:
	movq xmm0, qword ptr [ecx+eax]	; throws exception here				
	pcmpeqb xmm1, xmm7
	packsswb xmm1, xmm1
	movd ebx, xmm1
	test ebx, ebx	; ex bl, bl
	lea eax, [eax+8]
	je @B
@@:
	movzx ebx, byte ptr [ecx+eax-8]		
	add eax, 1
	test ebx, ebx	; ex bl, bl
	mov [edx+eax-9], bl
	jnz @B
	; mov ebx, [esp+2*4]	; not faster than pop
	pop ebx
	ret 2*4
MbCopy endp

COMMENT ^
ml v614
004019C0              ? 0FEFC9                      pxor mm1, mm1
004019C3              > 0F1006                      movups xmm0, dqword ptr [esi]
004019C6              . 0F74C8                      pcmpeqb mm1, mm0
004019C9              . 0FD7C9                      pmovmskb ecx, mm1
004019CC              . 85C9                        test ecx, ecx
004019CE              .75 0B                       jne short SzCpy.004019DB
004019D0              . 0F1107                      movups dqword ptr [edi], xmm0

ml v9
004019C8              ? 660FEFC9                    pxor xmm1, xmm1
004019CC              . 0F1006                      movups xmm0, dqword ptr [esi]
004019CF              ? 660F74C8                    pcmpeqb xmm1, xmm0
004019D3              . 660FD7C9                    pmovmskb ecx, xmm1
004019D7              ? 85C9                        test ecx, ecx
004019D9              .75 0B                       jne short SzCpy.004019E6
004019DB              > 0F1107                      movups dqword ptr [edi], xmm0

JWasm
004019C8              ? 660FEFC9                    pxor xmm1, xmm1
004019CC              . 0F1006                      movups xmm0, dqword ptr [esi]
004019CF              ? 660F74C8                    pcmpeqb xmm1, xmm0
004019D3              . 660FD7C9                    pmovmskb ecx, xmm1
004019D7              ? 85C9                        test ecx, ecx
004019D9              .75 0B                       jne short SzCpy.004019E6
004019DB              > 0F1107                      movups dqword ptr [edi], xmm0
^

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
comment * inspired by "MMX  Fast" by Mark Larson *
; align 16	; seems to have NO influence
szCopyXMM proc dest:DWORD, src:DWORD
  saveregs=0
  ChkFPU=0
  if ChkFPU
	call LoadFPU
  endif
  if 0
	cmp CanSSE2, 0  	; test CanSSE2, 1 is longer
	je @F
  endif
  if saveregs
	push esi
	push edi
	mov esi, [esp+8+8]
	mov edi, [esp+4+8]
	push ecx	; preserve another valuable register
  else
	mov esi, [esp+8]
	mov edi, [esp+4]
  endif
  pxor xmm1, xmm1
@@:
  movups xmm0, [esi] 
  pcmpeqb xmm1, xmm0
  pmovmskb ecx, xmm1	; Move Byte Mask To Integer - a fantastic instruction!
  test ecx,ecx 
  jnz @F
  movups [edi], xmm0
  add esi, 16
  add edi, 16
  jmp @B
@@:
  .Repeat
	lodsb	; relatively slow
	stosb	; tail cleanup
  .Until al==0
  mov eax, edi		; a stringcat routine might need this one
  if saveregs
	pop ecx		; save ecx
	pop edi
	pop esi
  endif
ret 8		; cleanup
szCopyXMM endp
jj1:


OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef

OPTION PROLOGUE:NONE   ; It  is SzCpy11  MMX  Fast by Lingo
OPTION EPILOGUE:NONE
comment * MMX by Lingo*
align 16
@@:
	movq		MM1,	[ecx+eax]
    movq		[edx+eax-8], MM0
@@21:
    movq		MM0,	[ecx+eax]					
	pcmpeqb	MM1,	MM7
	packsswb	MM1,	MM1
	movd		ebx,		MM1
	test			ebx,		ebx
	lea			eax,		[eax+8]
	je				@B
	mov			ebx, [esp+2*4]						
	ret			2*4
align 16
SzCpy11   proc    SzDest:DWORD, SzSource:DWORD
;int 3
;				finit			trashes the FPU
;				mov eax, 12345678
;				push eax
;				fild dword ptr [esp]
				mov		ecx, [esp+2*4]		; ecx = source
				xor		eax, eax
				mov		edx, [esp+1*4]		;  edx= destination
 				pxor		MM7,MM7
				movq	MM1, [ecx]
				mov		[esp+2*4], ebx		;  save ebx register
				je			@@21
 SzCpy11 endp
OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef


OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 
comment * MMX by Mark Larson *

align 16
szCopyMMX proc near src_str:DWORD, dst_str:DWORD
   mov eax,[esp+4]
   mov esi,[esp+8]


align 16
qword_copy:
   pxor MM1,MM1
   movq MM0,[eax] 
   pcmpeqb MM1,MM0
   add eax,8 
   pmovmskb ecx,MM1
   or ecx,ecx 
   jnz finish_rest
   movq [esi],MM0
   add esi,8
   jmp qword_copy

finish_rest:
;ret 8

;if 0
bsf ecx,ecx
cmp ecx,7
je do_7
cmp ecx,6
je do_6
cmp ecx,5
je do_5
cmp ecx,4
je do_4
cmp ecx,3
je do_3
cmp ecx,2
je do_2

do_7:
mov ecx,[eax-8]
mov edx,[eax+4-8] ;really copy 8 bytes to include the 0
mov [esi],ecx
mov [esi+4],edx
ret 8 ; ret

do_6:
mov ecx,[eax-8]
movzx edx,word ptr[eax+4-8]
mov [esi],ecx
mov [esi+4],dx
mov byte ptr [esi+6],0
ret 8 ; ret

do_5:
mov ecx,[eax-8]
movzx edx,byte ptr[eax+4-8]
mov [esi],ecx
mov [esi+4],dl
mov byte ptr [esi+5],0
ret 8 ; ret


do_4:
mov ecx,[eax-8]
mov [esi],ecx
mov byte ptr [esi+4],0
ret 8 ; ret


do_3:
movzx ecx,word ptr[eax-8]
movzx edx,byte ptr[eax+2-8]
mov [esi],cx
mov [esi+2],dl
mov byte ptr [esi+3],0
ret 8 ; ret

do_2:
movzx ecx,word ptr[eax-8]
mov byte ptr [esi+2],0
ret 8 ; ret

;cmp ecx,1
;je do_1
movzx ecx,byte ptr [eax-8]
mov [esi],cl
ret 8 ; ret

szCopyMMX endp
OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef       


OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 
comment * MMX  Fast by Mark Larson *

align 16
szCopyMMX1 proc near src_str:DWORD, dst_str:DWORD
   mov eax,[esp+4]
   mov esi,[esp+8]

align 16
qword_copy1:
   pxor MM1,MM1
   movq MM0,[eax] 
   pcmpeqb MM1,MM0
   add eax,8 
   pmovmskb ecx,MM1
   or ecx,ecx 
   jnz finish_rest1
   movq [esi],MM0
   add esi,8
   jmp qword_copy1
finish_rest1:
ret 8
szCopyMMX1 endp
OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef       

LoadFPU proc						; test: load all 8 FPU regs
		if ChkFPU
			finit
		endif
		xor eax, eax
		ifndef f2sP10
			.data?
			f2sP10	dd ?
			.code
		endif
		mov ecx, offset f2sP10	; clear the first table entry to
		mov [ecx], eax			; signal it has to be created again
		mov ecx, 8
@@:		push ecx
		fild dword ptr [esp]
		pop ecx
		dec ecx
		jne @B
;		pushad
;		print chr$(13, 10, "Init", 13,10)
;		popad
		ret
LoadFPU endp

End Start
OPT_Assembler mlv614
OPT_Tmp2Asm	1
OPT_Res	0
